''' <summary>
''' 
''' </summary>
''' <remarks></remarks>
Public Class frmLineSegmentDemo
    Private objLineSegment As New GraphicsControls.LineSegment
    'Keep up with the line control that the user clicked on.
    Private objSelectedLineSegment As GraphicsControls.LineSegment = Nothing

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'There are two ways to define a line programmatically.

        '1) Set the StartPoint and EndPoint.  Then, add points between them
        objLineSegment.StartPoint = New Point(150, 20)
        objLineSegment.EndPoint = New Point(220, 50)
        objLineSegment.AddPoint(New Point(100, 100), 0)
        objLineSegment.AddPoint(New Point(200, 200), 1)

        '2) Directly access the LineSegment's points array
        'ReDim Me.objLineSegment.Points(3)
        'objLineSegment.Points(0) = New Point(150, 20)
        'objLineSegment.Points(1) = New Point(100, 100)
        'objLineSegment.Points(2) = New Point(200, 200)
        'objLineSegment.Points(3) = New Point(220, 50)

        'Set the color and width properties
        objLineSegment.BorderWidth = 5
        objLineSegment.BorderColor = Color.FromArgb(0, 0, 255)

        'The hilite properties tell the line how to display itself when a mouse over happens
        objLineSegment.BorderWidthHiLite = 7
        objLineSegment.BorderColorHiLite = Color.FromArgb(100, 100, 255)

        'Hook up the context menu
        objLineSegment.ContextMenuStrip = Me.mnuLineSegment

        Controls.Add(objLineSegment)

    End Sub

    ''' <summary>
    ''' Keep up with the line segment object that the context menu is over
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub mnuLineSegment_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles mnuLineSegment.Opening
        Try
            objSelectedLineSegment = sender.sourcecontrol
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    ''' <summary>
    ''' User selected to add a new point
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub mnuAddSegmentToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAddSegmentToolStripMenuItem.Click
        Try
            If Not IsNothing(objSelectedLineSegment) Then
                'Call the AddPoint method.  This will add a new point at the current mouse location
                'This method has overloads that allow you to specify the new point to add as well as the
                'index position to add it.
                objSelectedLineSegment.AddPoint()
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    ''' <summary>
    ''' User selected to delete a point
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub mnuDeleteSegmentToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuDeleteSegmentToolStripMenuItem.Click
        Try
            If Not IsNothing(objSelectedLineSegment) Then
                'Call the DeletePoint method.  It will delete the point closest to the mouse.
                'There is an overload that allows you to specify the particular index to delete.
                objSelectedLineSegment.DeletePoint()
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cmdNewLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNewLine.Click
        Dim objNewLine As GraphicsControls.LineSegment = Nothing
        Try
            objNewLine = New GraphicsControls.LineSegment

            objNewLine.StartPoint = New Point(10, 20)
            objNewLine.EndPoint = New Point(175, 100)

            'Set the color and width properties
            objNewLine.BorderWidth = 4
            objNewLine.BorderColor = Color.FromArgb(255, 0, 255)

            'The hilite properties tell the line how to display itself when a mouse over happens
            objNewLine.BorderWidthHiLite = 6
            objNewLine.BorderColorHiLite = Color.FromArgb(255, 100, 255)

            'Hook up the context menu
            objNewLine.ContextMenuStrip = Me.mnuLineSegment

            Controls.Add(objNewLine)

        Catch ex As Exception

        End Try
    End Sub
End Class
